package com.zksy.controller.property;

import cn.hutool.core.date.DateTime;
import com.zksy.property.domain.APropertyReceipt;
import com.zksy.property.domain.ARentalProperty;
import com.zksy.property.service.APropertyReceiptService;
import com.zksy.property.service.ARentalPropertyService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 标准化厂房收入情况控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/apropertyReceipt")
@Api(tags = "标准化厂房收入情况信息",description = "标准化厂房收入情况信息desc")
public class APropertyReceiptController {
    @Autowired
    private APropertyReceiptService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "标准化厂房收入情况信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String unit,String building){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, unit,building));
    }
    @GetMapping("/getARentalPropertyList")
    @ApiOperation(value = "标准化厂房收入情况信息查询")
    public AjaxResult getAPropertyReceiptList(String unit,String building){
        return AjaxResult.success(service.getAPropertyReceiptList(unit,building));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询标准化厂房收入情况信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "标准化厂房收入情况信息保存")
    public AjaxResult save(@RequestBody APropertyReceipt eAdminLicenseInfo) {
        return service.save(eAdminLicenseInfo) ? AjaxResult.success(eAdminLicenseInfo) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "标准化厂房收入情况信息修改")
    public AjaxResult update(@RequestBody APropertyReceipt eAdminLicenseInfo) {
        eAdminLicenseInfo.setUpdateTime(LocalDateTime.now());
        return service.updateById(eAdminLicenseInfo) ? AjaxResult.success(eAdminLicenseInfo) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "标准化厂房收入情况信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, APropertyReceipt.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String unit,String building) {
        ExcelExportUtil.exportExcel(response,service.getAPropertyReceiptList(unit,building), APropertyReceipt.class, "标准化厂房收入情况信息","标准化厂房收入情况信息");
    }

}
